(use '[clojure.java.io])

; ハノイの塔
(defn hanoi [n from to via]
  (if (> n 1)
    (do
      (hanoi (dec n) from via to)
      (println (format "%s -> %s" from to))
      (hanoi (dec n) via to from))
    (println (format "%s -> %s" from to))))

(doseq [n (line-seq (reader *in*))]
  (hanoi (read-string n) 'a 'b 'c))
