#import <Foundation/Foundation.h>

/* ハノイの塔 */
@interface Hanoi : NSObject
- (void)hanoi: (int)n from: (char)from to: (char)to via: (char)via;
@end

@implementation Hanoi
- (void)hanoi: (int)n from: (char)from to: (char)to via: (char)via {
  if (n > 1) {
    [self hanoi: n - 1 from: from to: via via: to];
    printf("%c -> %c\n", from, to);
    [self hanoi: n - 1 from: via to: to via: from];
  } else {
    printf("%c -> %c\n", from, to);
  }
}

int main() {
  id h = [[Hanoi alloc] init];
  int n;
  scanf("%d", &n);
  [h hanoi: n from: 'a' to: 'b' via: 'c'];
  return 0;
}
@end
