using System;

public class Hanoi
{ // ハノイの塔
  public Exec(n: int, from: string, to: string, via:string) : void
  {
    if (n > 1)
    {
      Exec(n - 1, from, via, to);
      System.Console.WriteLine(from + " -> " + to);
      Exec(n - 1, via, to, from);
    }
    else
    {
      System.Console.WriteLine(from + " -> " + to);
    }
  }
  public static Main() : void
  {
    def n: int = int.Parse(System.Console.ReadLine());
    def h: Hanoi = Hanoi();
    h.Exec(n, "a", "b", "c");
  }
}
