use std::io;

/*
ハノイの塔
*/
fn hanoi(n: i32, from: char, to: char, via: char) {
    if n > 1 {
        hanoi(n - 1, from, via, to);
        println!("{} -> {}", from, to);
        hanoi(n - 1, via, to, from);
    } else {
        println!("{} -> {}", from, to);
    }
}

fn main() {
    // 標準入力から段数を取得して実行
    let mut n = String::new();
    io::stdin().read_line(&mut n);

    hanoi(n.parse().unwrap(), 'a', 'b', 'c');
}
