-- ハノイの塔
CREATE TABLE input (v INTEGER);
.import /dev/stdin input
CREATE TABLE tower (val);
INSERT INTO tower VALUES ('a'),('b'),('c');
CREATE table move(seq, f1, t1, v1, f2, t2, v2);
INSERT INTO move SELECT 1, a.val, b.val, c.val, a.val, c.val, b.val
    FROM tower a CROSS JOIN tower b CROSS JOIN tower c
    WHERE (a.val <> b.val) AND (a.val <> c.val) AND (b.val <> c.val);
INSERT INTO move SELECT 2, a.val, b.val, c.val, a.val, b.val, '0'
    FROM tower a CROSS JOIN tower b CROSS JOIN tower c
    WHERE (a.val <> b.val) AND (a.val <> c.val) AND (b.val <> c.val);
INSERT INTO move SELECT 3, a.val, b.val, c.val, c.val, b.val, a.val
    FROM tower a CROSS JOIN tower b CROSS JOIN tower c
    WHERE (a.val <> b.val) AND (a.val <> c.val) AND (b.val <> c.val);
WITH RECURSIVE hanoi(n, f, t, v, s) AS (
    VALUES ((SELECT v FROM input), 'a', 'b', 'c', '')
  UNION ALL
    SELECT n - 1, f2, t2, v2, s || seq FROM hanoi
    LEFT OUTER JOIN move ON f = f1 AND t = t1 AND v = v1 WHERE n > 0
)
SELECT f || ' -> ' || t FROM hanoi WHERE v = '0' ORDER BY s;
