package {
    import flash.display.*;
    import flash.text.*;

    // ハノイの塔
    public class Hanoi extends Sprite {
        private var result:String = "";
        private function hanoi(n:int, from:String, to:String,
                               via:String):void{
            if (n > 1){
                hanoi(n - 1, from, via, to);
                result += from + " -> " + to + "\n";
                hanoi(n - 1, via, to, from);
            } else {
                result += from + " -> " + to + "\n";
            }
        }

        public function Hanoi(){
            var n:int = 3;
            var textField:TextField = new TextField();
            hanoi(n, "a", "b", "c");

            textField.text = result;
            textField.autoSize = TextFieldAutoSize.CENTER;
            addChild(textField);
        }
    }
}