import java.util.*;

/*
ハノイの塔
*/
class Hanoi{
  private void hanoi(int n, char from, char to, char via){
    if (n > 1){
      hanoi(n - 1, from, via, to);
      System.out.println(from + " -> " + to);
      hanoi(n - 1, via, to, from);
    } else {
      System.out.println(from + " -> " + to);
    }
  }

  public static void main(String args[]){
    // 標準入力から段数を取得して実行
    Scanner cin = new Scanner(System.in);
    if (cin.hasNext()){
      int n = Integer.parseInt(cin.nextLine());
      Hanoi h = new Hanoi();
      h.hanoi(n, 'a', 'b', 'c');
    }
  }
}
