# ハノイの塔
defmodule Hanoi do
  def hanoi(1, from, to, _), do: IO.puts "#{from} -> #{to}"
  def hanoi(n, from, to, via) do
    hanoi(n - 1, from, via, to)
    IO.puts "#{from} -> #{to}"
    hanoi(n - 1, via, to, from)
  end
end

# 標準入力から段数を取得して実行
n = String.to_integer(IO.gets "")
Hanoi.hanoi(n, "a", "b", "c")
