package main
import "fmt"

/*
ハノイの塔
*/
func hanoi(n int, from, to, via string) {
    if n > 1 {
        hanoi(n - 1, from, via, to)
        fmt.Println(from, " -> ", to)
        hanoi(n - 1, via, to, from)
    } else {
        fmt.Println(from, " -> ", to)
    }
}

func main(){
    // 標準入力から段数を取得して実行
    var n int
    fmt.Scan(&n)
    hanoi(n, "a", "b", "c")
}
